<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;

class RelVendasRealizadasPeriodo  {
    protected $dataSourceName = 'vnd41208Q_relVendasRealizadasPeriodo';
    protected $vndsRealizadasService;
    protected $relService;

    public function __construct (Services\VendasRealizadasPeriodo $vndsRealizadasService, Services\RelatorioService $relService) {
        $this->vndsRealizadasService = $vndsRealizadasService;
        $this->relService = $relService;
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            $conditions = $this->relService->getParamsAsArray($request);

            $this->relService->setTCDandCDChangingKey($conditions, 'CDCAIXA',           'CDFILICAIXA');
            $this->relService->setTCDandCDChangingKey($conditions, 'CLIENFILIAL',       'CDFILICLIENTE');
            $this->relService->setTCDandCDChangingKey($conditions, 'CLIENTECONSUMIDOR', 'CDCONSCLI');
            $this->relService->setTCDandCDChangingKey($conditions, 'CDFILIAL',          'CDFILIAL');
            $this->relService->setIntervalAsDTINIandDTFIM($conditions, 'DTMOVIMENTO',   'DTINI', 'DTFIM');
            $response->addDataSet(new DataSet("vnd41208Q_relVendasRealizadasPeriodo", $this->vndsRealizadasService->getReport($conditions)));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}