<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Doctrine\DBAL\Connection;


class Loja {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function buscaLojasFilial($CDFILIAL) {

		$params = array(
			':CDFILIAL' => $CDFILIAL
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_LOJAS_FILIAL, $params);
	}

	public function getSetorsLoja($CDFILIAL, $CDLOJA){
		$params = array(
			':CDLOJA' => $CDLOJA,
			':CDFILIAL' => $CDFILIAL
		);

	return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_SETORES_LOJA, $params);
	}

	public function getSetorsDisponiveisLoja($CDFILIAL, $CDLOJA){
		$params = array(
			':CDLOJA' => $CDLOJA,
			':CDFILIAL' => $CDFILIAL
		);

	return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_SETORES_DISPONIVEIS_LOJA, $params);
	}
	
	public function deleteLoja($CDFILIAL, $CDLOJA, $NRORG){
		$params = array(
            ':CDFILIAL' =>  $CDFILIAL,
            ':CDLOJA' => $CDLOJA,
            ':NRORG'    =>  $NRORG
        );
        $result = $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_LOJA, $params);
        return $result;
	}
}