<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;
use Teknisa\Libs\Util\Environment;


class ParaEmailRespService {
	protected $entityManager;
	protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
    public function novoCodigo($conditions){
		return NovoCodigo::geraCodigo($this->entityManager->getConnection(), 'CADASTROSUBPROJETO', $conditions[0]['NRORG'], 3);
    }
    
	public function novoCodigoExterno($contador, $conditions){
		return NovoCodigo::geraCodigo($this->entityManager->getConnection(), $contador, $conditions['NRORG'], 10);
    }
    
    //public function novoCodigoProjetoLocal($conditions){
		//return NovoCodigo::geraCodigo($this->entityManager->getConnection(), 'PROJETOLOCAL', $conditions[0]['NRORG'], 10);
    //}
    
    public function deleteInfosUnidadeParticipantes ($params){
		try {
			// deleta emails e códigos externos unidades participantes	
			$this->entityManager->getConnection()->executeQuery(self::DELETE_EMAIL_UNID_PART, $params);
			$this->entityManager->getConnection()->executeQuery(self::DELETE_COD_INTE_UNIDADE, $params);
		} catch (\Exception $e) {
			throw $e;
		}
    }
    
    public function deleteInfosUnidadeParticipantesSubProjeto ($params){
		try {
			// deleta emails e códigos externos unidades participantes	do SubProjeto
			$this->entityManager->getConnection()->executeQuery(self::DELETE_EMAIL_UNID_PART_SUBPROJETO, $params);
			$this->entityManager->getConnection()->executeQuery(self::DELETE_COD_INTE_UNIDADE_SUBPROJETO, $params);
		} catch (\Exception $e) {
			throw $e;
		}
    }
    
    public function deleteInfosSubProjeto ($params) {
    	try {
			$this->entityManager->getConnection()->executeQuery(self::DELETE_EMAIL_SUBPROJETO, $params);
			$this->entityManager->getConnection()->executeQuery(self::DELETE_COD_INTE_SUBPROJETO, $params);
		} catch (\Exception $e) {
			throw $e;
		}
    }
    
    public function exportarCod($conditions){
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$paramsCod = array(
    	                ':CDPRODUTO' => $produto,
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	            	$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	            	$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$paramsCod = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	    			$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	    			$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	                
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }

	}
    
    public function autoSaveCod($conditions){
    	$contadorCod = 'contadorCod';
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCod, $conditions);
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCod, $conditions); 
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }
	}
	
	public function exportarCodUnidade($conditions){
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$paramsCod = array(
    	                ':CDPRODUTO' => $produto,
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	            	$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	            	$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIALDESTINO']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$paramsCod = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	    			$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	    			$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIALDESTINO']
    	                
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }

	}
    
    public function autoSaveCodUnidade($conditions){
    	$contadorCodUnidade = 'contadorCodUnidade';
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCodUnidade, $conditions);
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCodUnidade, $conditions); 
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	                
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }
	}
	
	public function exportarCodSubProjeto($conditions){
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$paramsCod = array(
    	                ':CDPRODUTO' => $produto,
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	            	$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	            	$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_SUBPROJETO, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$paramsCod = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	    			$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	    			$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_SUBPROJETO, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }

	}
    
    public function autoSaveCodSubProjeto($conditions){
    	$contadorCodSubProjeto = 'contadorCodSubProjeto';
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCodSubProjeto, $conditions);
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_SUBPROJETO, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCodSubProjeto, $conditions); 
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_SUBPROJETO, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }
	}
	
	public function exportarCodUnidadeSubProjeto($conditions){
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$paramsCod = array(
    	                ':CDPRODUTO' => $produto,
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	            	$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	            	$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'     => $conditions['CDFILIALDESTINO'],
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE_SUBPROJETO, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$paramsCod = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'	 => $conditions['CDFILIAL']
    	            );
	    			$conditions['CDPRODINTE'] = $this->entityManager->getConnection()->fetchAll(self::GET_COD_PRODEXTERNO, $paramsCod);
	    			$conditions['CDPRODINTE'] = $conditions['CDPRODINTE'][0]['CDPRODUTOEXT'];
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'     => $conditions['CDFILIALDESTINO'],
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE_SUBPROJETO, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }

	}
    
    public function autoSaveCodUnidadeSubProjeto($conditions){
    	$contadorCodUnidadeSubProjeto = 'contadorCodUnidadeSubProjeto';
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
	            	$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCodUnidadeSubProjeto, $conditions);
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'     => $conditions['CDFILIAL'],
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE_SUBPROJETO, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIM' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$conditions['CDPRODINTE'] = $this->novoCodigoExterno($contadorCodUnidadeSubProjeto, $conditions); 
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':CDPRODINTE'=> $conditions['CDPRODINTE'],
    	                ':CDPROJETO' => $conditions['CDPROJETO'],
    	                ':CDSUBPROJETO' => $conditions['CDSUBPROJETO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'     => $conditions['CDFILIAL'],
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_MAPEAMENTO_UNIDADE_SUBPROJETO, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }
	}
    
    
    
    const DELETE_EMAIL_UNID_PART = "DELETE 
    FROM LISTAEMAILTECLOCAL 
    WHERE  (NRORG    = :NRORG) 
    AND (CDPROJETO   = :CDPROJETO) 
    AND (CDFILIAL = :CDFILIAL) 
    AND  CDSUBPROJETO IS NULL";
    
    const DELETE_COD_INTE_UNIDADE = "DELETE 
    FROM PRODEXTERNOINTE 
    WHERE  (NRORG    = :NRORG) 
    AND (CDPROJETO   = :CDPROJETO)
    AND (CDFILIAL = :CDFILIAL)
    AND  CDSUBPROJETO IS NULL";
    
    const DELETE_EMAIL_UNID_PART_SUBPROJETO = "DELETE 
    FROM LISTAEMAILTECLOCAL 
    WHERE  (NRORG   	 = :NRORG) 
    AND    (CDPROJETO    = :CDPROJETO) 
    AND    (CDFILIAL	 = :CDFILIAL) 
    AND    (CDSUBPROJETO = :CDSUBPROJETO)";
	
    const DELETE_COD_INTE_UNIDADE_SUBPROJETO = "DELETE 
    FROM PRODEXTERNOINTE 
    WHERE  (NRORG    = :NRORG) 
    AND (CDPROJETO   = :CDPROJETO)
    AND (CDFILIAL = :CDFILIAL)
    AND (CDSUBPROJETO = :CDSUBPROJETO)";
    
    const DELETE_EMAIL_SUBPROJETO = "DELETE 
    FROM LISTAEMAILTECLOCAL 
    WHERE  (NRORG    = :NRORG) 
    AND (CDPROJETO   = :CDPROJETO)
    AND  (CDSUBPROJETO = :CDSUBPROJETO)";
    
    const DELETE_COD_INTE_SUBPROJETO = "DELETE 
    FROM PRODEXTERNOINTE 
    WHERE  (NRORG    = :NRORG) 
    AND (CDPROJETO   = :CDPROJETO)
    AND  (CDSUBPROJETO = :CDSUBPROJETO)";
    
	const ADD_MAPEAMENTO = "
	INSERT INTO PRODEXTERNOINTE 
	    (CDPRODUTO, CDPRODINTE, CDPROJETO, NRORG)
    VALUES 
        (:CDPRODUTO, :CDPRODINTE, :CDPROJETO, :NRORG)";
        
	const ADD_MAPEAMENTO_UNIDADE = "
	INSERT INTO PRODEXTERNOINTE 
	    (CDPRODUTO, CDPRODINTE, CDPROJETO, NRORG, CDFILIAL)
    VALUES 
        (:CDPRODUTO, :CDPRODINTE, :CDPROJETO, :NRORG, :CDFILIAL)";
        
	const ADD_MAPEAMENTO_SUBPROJETO = "
	INSERT INTO PRODEXTERNOINTE 
	    (CDPRODUTO, CDPRODINTE, CDPROJETO, CDSUBPROJETO, NRORG)
    VALUES 
        (:CDPRODUTO, :CDPRODINTE, :CDPROJETO, :CDSUBPROJETO, :NRORG)";
    
    const ADD_MAPEAMENTO_UNIDADE_SUBPROJETO = "
	INSERT INTO PRODEXTERNOINTE 
	    (CDPRODUTO, CDPRODINTE, CDPROJETO, CDSUBPROJETO, NRORG, CDFILIAL)
    VALUES 
        (:CDPRODUTO, :CDPRODINTE, :CDPROJETO, :CDSUBPROJETO, :NRORG, :CDFILIAL)";
        
    const GET_PROD_INTERVALO = "
		SELECT PR.CDPRODUTO
		FROM PRODUTO PR
		WHERE (PR.NRORG = :NRORG)
		  AND (PR.CDPRODUTO BETWEEN :CDPRODINI AND :CDPRODFIM)
		  AND (PR.CDNVPRODUTO IN (SELECT MAX(CDNVPRODUTO) FROM PRODUTO))
		ORDER BY PR.CDPRODUTO
	";
	
	const GET_COD_PRODEXTERNO = "
		SELECT CDPRODUTOEXT
		FROM PRODEXTERNO
		WHERE (CDPRODUTO = :CDPRODUTO)
		  AND (CDFILIAL = :CDFILIAL)
		  AND (NRORG = NRORG)
	";
}








